diff --git a/rsvg-styles.h b/rsvg-styles.h
index 7f91836..a044d3f 100644
--- a/rsvg-styles.h
+++ b/rsvg-styles.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-styles.h: Handle SVG styles
 
@@ -26,6 +27,7 @@
 #ifndef RSVG_STYLES_H
 #define RSVG_STYLES_H
 
+#include <cairo.h>
 #include "rsvg.h"
 #include "rsvg-paint-server.h"
 
@@ -49,11 +51,6 @@ typedef enum {
     TEXT_ANCHOR_END
 } TextAnchor;
 
-enum {
-    FILL_RULE_EVENODD = 0,
-    FILL_RULE_NONZERO = 1
-};
-
 typedef enum {
     UNICODE_BIDI_NORMAL = 0,
     UNICODE_BIDI_EMBED = 1,
@@ -61,65 +58,12 @@ typedef enum {
 } UnicodeBidi;
 
 typedef enum {
-    SHAPE_RENDERING_AUTO = 0,
-    SHAPE_RENDERING_OPTIMIZE_SPEED,
-    SHAPE_RENDERING_CRISP_EDGES,
-    SHAPE_RENDERING_GEOMETRIC_PRECISION
-} ShapeRenderingProperty;
-
-typedef enum {
-    TEXT_RENDERING_AUTO = 0,
-    TEXT_RENDERING_OPTIMIZE_SPEED,
-    TEXT_RENDERING_OPTIMIZE_LEGIBILITY,
-    TEXT_RENDERING_GEOMETRIC_PRECISION
-} TextRenderingProperty;
-
-typedef enum {
-    RSVG_COMP_OP_CLEAR,
-    RSVG_COMP_OP_SRC,
-    RSVG_COMP_OP_DST,
-    RSVG_COMP_OP_SRC_OVER,
-    RSVG_COMP_OP_DST_OVER,
-    RSVG_COMP_OP_SRC_IN,
-    RSVG_COMP_OP_DST_IN,
-    RSVG_COMP_OP_SRC_OUT,
-    RSVG_COMP_OP_DST_OUT,
-    RSVG_COMP_OP_SRC_ATOP,
-    RSVG_COMP_OP_DST_ATOP,
-    RSVG_COMP_OP_XOR,
-    RSVG_COMP_OP_PLUS,
-    RSVG_COMP_OP_MULTIPLY,
-    RSVG_COMP_OP_SCREEN,
-    RSVG_COMP_OP_OVERLAY,
-    RSVG_COMP_OP_DARKEN,
-    RSVG_COMP_OP_LIGHTEN,
-    RSVG_COMP_OP_COLOR_DODGE,
-    RSVG_COMP_OP_COLOR_BURN,
-    RSVG_COMP_OP_HARD_LIGHT,
-    RSVG_COMP_OP_SOFT_LIGHT,
-    RSVG_COMP_OP_DIFFERENCE,
-    RSVG_COMP_OP_EXCLUSION
-} RsvgCompOpType;
-
-typedef enum {
     RSVG_ENABLE_BACKGROUND_ACCUMULATE,
     RSVG_ENABLE_BACKGROUND_NEW
 } RsvgEnableBackgroundType;
 
 /* enums and data structures are ABI compatible with libart */
 
-typedef enum {
-    RSVG_PATH_STROKE_JOIN_MITER,
-    RSVG_PATH_STROKE_JOIN_ROUND,
-    RSVG_PATH_STROKE_JOIN_BEVEL
-} RsvgPathStrokeJoinType;
-
-typedef enum {
-    RSVG_PATH_STROKE_CAP_BUTT,
-    RSVG_PATH_STROKE_CAP_ROUND,
-    RSVG_PATH_STROKE_CAP_SQUARE
-} RsvgPathStrokeCapType;
-
 typedef struct _RsvgVpathDash RsvgVpathDash;
 
 struct _RsvgVpathDash {
@@ -131,14 +75,16 @@ struct _RsvgVpathDash {
 /* end libart theft... */
 
 struct _RsvgState {
-    double affine[6];
-    double personal_affine[6];
+    RsvgState *parent;
+    cairo_matrix_t affine;
+    cairo_matrix_t personal_affine;
 
-    RsvgFilter *filter;
-    void *mask;
-    void *clip_path_ref;
-    guint8 adobe_blend;         /* 0..11 */
+    char *filter;
+    char *mask;
+    char *clip_path;
     guint8 opacity;             /* 0..255 */
+    double baseline_shift;
+    gboolean has_baseline_shift;
 
     RsvgPaintServer *fill;
     gboolean has_fill_server;
@@ -161,9 +107,9 @@ struct _RsvgState {
     double miter_limit;
     gboolean has_miter_limit;
 
-    RsvgPathStrokeCapType cap;
+    cairo_line_cap_t cap;
     gboolean has_cap;
-    RsvgPathStrokeJoinType join;
+    cairo_line_join_t join;
     gboolean has_join;
 
     RsvgLength font_size;
@@ -184,6 +130,8 @@ struct _RsvgState {
     gboolean has_font_decor;
     PangoDirection text_dir;
     gboolean has_text_dir;
+    PangoGravity text_gravity;
+    gboolean has_text_gravity;
     UnicodeBidi unicode_bidi;
     gboolean has_unicode_bidi;
     TextAnchor text_anchor;
@@ -220,54 +168,79 @@ struct _RsvgState {
     guchar flood_opacity;
     gboolean has_flood_opacity;
 
-    RsvgNode *startMarker;
-    RsvgNode *middleMarker;
-    RsvgNode *endMarker;
+    char *startMarker;
+    char *middleMarker;
+    char *endMarker;
     gboolean has_startMarker;
     gboolean has_middleMarker;
     gboolean has_endMarker;
 
-    RsvgCompOpType comp_op;
+    cairo_operator_t comp_op;
     RsvgEnableBackgroundType enable_background;
 
-    ShapeRenderingProperty shape_rendering_type;
+    cairo_antialias_t shape_rendering_type;
     gboolean has_shape_rendering_type;
-    
-    TextRenderingProperty text_rendering_type;
+
+    cairo_antialias_t text_rendering_type;
     gboolean has_text_rendering_type;
-};
 
-RsvgState *rsvg_state_new ();
+    GHashTable *styles;
+};
 
-void rsvg_state_init	    (RsvgState * state);
-void rsvg_state_clone	    (RsvgState * dst, const RsvgState * src);
-void rsvg_state_inherit	    (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
+RsvgState *rsvg_state_new (void);
+
+G_GNUC_INTERNAL
+void rsvg_state_init        (RsvgState * state);
+G_GNUC_INTERNAL
+void rsvg_state_reinit      (RsvgState * state);
+G_GNUC_INTERNAL
+void rsvg_state_clone       (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
+void rsvg_state_inherit     (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
 void rsvg_state_reinherit   (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
 void rsvg_state_dominate    (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
 void rsvg_state_override    (RsvgState * dst, const RsvgState * src);
+G_GNUC_INTERNAL
 void rsvg_state_finalize    (RsvgState * state);
+G_GNUC_INTERNAL
+void rsvg_state_free_all    (RsvgState * state);
 
+G_GNUC_INTERNAL
 void rsvg_parse_style_pairs (RsvgHandle * ctx, RsvgState * state, RsvgPropertyBag * atts);
-void rsvg_parse_style_pair  (RsvgHandle * ctx, RsvgState * state, const char *key, const char *val);
+G_GNUC_INTERNAL
 void rsvg_parse_style	    (RsvgHandle * ctx, RsvgState * state, const char *str);
+G_GNUC_INTERNAL
 void rsvg_parse_cssbuffer   (RsvgHandle * ctx, const char *buff, size_t buflen);
-
+G_GNUC_INTERNAL
 void rsvg_parse_style_attrs (RsvgHandle * ctx, RsvgState * state, const char *tag,
                              const char *klazz, const char *id, RsvgPropertyBag * atts);
 
-gdouble rsvg_viewport_percentage    (gdouble width, gdouble height);
-gdouble rsvg_dpi_percentage	    (RsvgHandle * ctx);
+G_GNUC_INTERNAL
+gdouble rsvg_viewport_percentage (gdouble width, gdouble height);
+G_GNUC_INTERNAL
+gdouble rsvg_dpi_percentage      (RsvgHandle * ctx);
 
-gboolean rsvg_parse_transform	    (double dst[6], const char *src);
+G_GNUC_INTERNAL
+gboolean rsvg_parse_transform   (cairo_matrix_t *matrix, const char *src);
 
-RsvgState *rsvg_state_parent	(RsvgDrawingCtx * ctx);
-RsvgState *rsvg_state_current	(RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+RsvgState *rsvg_state_parent    (RsvgState * state);
 
-void rsvg_state_pop	(RsvgDrawingCtx * ctx);
-void rsvg_state_push	(RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+void       rsvg_state_pop       (RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+void       rsvg_state_push      (RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+RsvgState *rsvg_current_state   (RsvgDrawingCtx * ctx);
 
+G_GNUC_INTERNAL
 void rsvg_state_reinherit_top	(RsvgDrawingCtx * ctx, RsvgState * state, int dominate);
 
+G_GNUC_INTERNAL
 void rsvg_state_reconstruct	(RsvgState * state, RsvgNode * current);
 
 G_END_DECLS
diff --git a/rsvg-text.c b/rsvg-text.c
index 05353dd..52e52c3 100644
--- a/rsvg-text.c
+++ b/rsvg-text.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-text.c: Text handling routines for RSVG
 
@@ -35,17 +36,6 @@
 /* what we use for text rendering depends on what cairo has to offer */
 #include <pango/pangocairo.h>
 
-#if defined CAIRO_HAS_FT_FONT
-#include <ft2build.h>
-#include FT_GLYPH_H
-#include FT_OUTLINE_H
-
-#include <pango/pangoft2.h>
-#elif defined (CAIRO_HAS_WIN32_FONT)
-/* nothing more needed? */
-#include <cairo-win32.h>
-#endif
-
 typedef struct _RsvgNodeText RsvgNodeText;
 
 struct _RsvgNodeText {
@@ -57,7 +47,7 @@ typedef struct _RsvgNodeTref RsvgNodeTref;
 
 struct _RsvgNodeTref {
     RsvgNode super;
-    RsvgNode *link;
+    char *link;
 };
 char *
 rsvg_make_valid_utf8 (const char *str, int len)
@@ -104,30 +94,30 @@ _rsvg_text_chomp (RsvgState *state, GString * in, gboolean * lastwasspace)
     guint i;
     out = g_string_new (in->str);
 
-	if (!state->space_preserve) {
-		for (i = 0; i < out->len;) {
-			if (out->str[i] == '\n')
-				g_string_erase (out, i, 1);
-			else
-				i++;
-		}
-		
-		for (i = 0; i < out->len; i++)
-			if (out->str[i] == '\t')
-				out->str[i] = ' ';
-		
-		for (i = 0; i < out->len;) {
-			if (out->str[i] == ' ' && *lastwasspace)
-				g_string_erase (out, i, 1);
-			else {
-				if (out->str[i] == ' ')
-					*lastwasspace = TRUE;
-				else
-					*lastwasspace = FALSE;
-				i++;
-			}
-		}
-	}
+    if (!state->space_preserve) {
+        for (i = 0; i < out->len;) {
+            if (out->str[i] == '\n')
+                g_string_erase (out, i, 1);
+            else
+                i++;
+        }
+
+        for (i = 0; i < out->len; i++)
+            if (out->str[i] == '\t')
+                out->str[i] = ' ';
+
+        for (i = 0; i < out->len;) {
+            if (out->str[i] == ' ' && *lastwasspace)
+                g_string_erase (out, i, 1);
+            else {
+                if (out->str[i] == ' ')
+                    *lastwasspace = TRUE;
+                else
+                    *lastwasspace = FALSE;
+                i++;
+            }
+        }
+    }
 
     return out;
 }
@@ -159,40 +149,55 @@ _rsvg_node_text_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * a
     }
 }
 
-void
+static void
  rsvg_text_render_text (RsvgDrawingCtx * ctx, const char *text, gdouble * x, gdouble * y);
 
 
 static void
  _rsvg_node_text_type_tspan (RsvgNodeText * self, RsvgDrawingCtx * ctx,
-                             gdouble * x, gdouble * y, gboolean * lastwasspace);
+                             gdouble * x, gdouble * y, gboolean * lastwasspace,
+                             gboolean usetextonly);
 
 static void
  _rsvg_node_text_type_tref (RsvgNodeTref * self, RsvgDrawingCtx * ctx,
-                            gdouble * x, gdouble * y, gboolean * lastwasspace);
+                            gdouble * x, gdouble * y, gboolean * lastwasspace,
+                            gboolean usetextonly);
 
+/* This function is responsible of selecting render for a text element including its children and giving it the drawing context */
 static void
 _rsvg_node_text_type_children (RsvgNode * self, RsvgDrawingCtx * ctx,
-                               gdouble * x, gdouble * y, gboolean * lastwasspace)
+                               gdouble * x, gdouble * y, gboolean * lastwasspace,
+                               gboolean usetextonly)
 {
     guint i;
 
     rsvg_push_discrete_layer (ctx);
     for (i = 0; i < self->children->len; i++) {
         RsvgNode *node = g_ptr_array_index (self->children, i);
-        if (!strcmp (node->type->str, "RSVG_NODE_CHARS")) {
+        RsvgNodeType type = RSVG_NODE_TYPE (node);
+
+        if (type == RSVG_NODE_TYPE_CHARS) {
             RsvgNodeChars *chars = (RsvgNodeChars *) node;
-            GString *str = _rsvg_text_chomp (rsvg_state_current (ctx), chars->contents, lastwasspace);
+            GString *str = _rsvg_text_chomp (rsvg_current_state (ctx), chars->contents, lastwasspace);
             rsvg_text_render_text (ctx, str->str, x, y);
             g_string_free (str, TRUE);
-        } else if (!strcmp (node->type->str, "tspan")) {
-            RsvgNodeText *tspan = (RsvgNodeText *) node;
-            rsvg_state_push (ctx);
-            _rsvg_node_text_type_tspan (tspan, ctx, x, y, lastwasspace);
-            rsvg_state_pop (ctx);
-        } else if (!strcmp (node->type->str, "tref")) {
-            RsvgNodeTref *tref = (RsvgNodeTref *) node;
-            _rsvg_node_text_type_tref (tref, ctx, x, y, lastwasspace);
+        } else {
+            if (usetextonly) {
+                _rsvg_node_text_type_children (node, ctx, x, y, lastwasspace,
+                                               usetextonly);
+            } else {
+                if (type == RSVG_NODE_TYPE_TSPAN) {
+                    RsvgNodeText *tspan = (RsvgNodeText *) node;
+                    rsvg_state_push (ctx);
+                    _rsvg_node_text_type_tspan (tspan, ctx, x, y, lastwasspace,
+                                                usetextonly);
+                    rsvg_state_pop (ctx);
+                } else if (type == RSVG_NODE_TYPE_TREF) {
+                    RsvgNodeTref *tref = (RsvgNodeTref *) node;
+                    _rsvg_node_text_type_tref (tref, ctx, x, y, lastwasspace,
+                                               usetextonly);
+                }
+            }
         }
     }
     rsvg_pop_discrete_layer (ctx);
@@ -200,34 +205,54 @@ _rsvg_node_text_type_children (RsvgNode * self, RsvgDrawingCtx * ctx,
 
 static int
  _rsvg_node_text_length_tref (RsvgNodeTref * self, RsvgDrawingCtx * ctx,
-                              gdouble * x, gboolean * lastwasspace);
+                              gdouble * x, gboolean * lastwasspace,
+                              gboolean usetextonly);
 
 static int
  _rsvg_node_text_length_tspan (RsvgNodeText * self, RsvgDrawingCtx * ctx,
-                               gdouble * x, gboolean * lastwasspace);
+                               gdouble * x, gboolean * lastwasspace,
+                               gboolean usetextonly);
 
 static gdouble rsvg_text_length_text_as_string (RsvgDrawingCtx * ctx, const char *text);
 
 static int
 _rsvg_node_text_length_children (RsvgNode * self, RsvgDrawingCtx * ctx,
-                                 gdouble * x, gboolean * lastwasspace)
+                                 gdouble * length, gboolean * lastwasspace,
+                                 gboolean usetextonly)
 {
     guint i;
     int out = FALSE;
     for (i = 0; i < self->children->len; i++) {
         RsvgNode *node = g_ptr_array_index (self->children, i);
-        if (!strcmp (node->type->str, "RSVG_NODE_CHARS")) {
+        RsvgNodeType type = RSVG_NODE_TYPE (node);
+
+        rsvg_state_push (ctx);
+        rsvg_state_reinherit_top (ctx, node->state, 0);
+        if (type == RSVG_NODE_TYPE_CHARS) {
             RsvgNodeChars *chars = (RsvgNodeChars *) node;
-            GString *str = _rsvg_text_chomp (rsvg_state_current (ctx), chars->contents, lastwasspace);
-            *x += rsvg_text_length_text_as_string (ctx, str->str);
+            GString *str = _rsvg_text_chomp (rsvg_current_state (ctx), chars->contents, lastwasspace);
+            *length += rsvg_text_length_text_as_string (ctx, str->str);
             g_string_free (str, TRUE);
-        } else if (!strcmp (node->type->str, "tspan")) {
-            RsvgNodeText *tspan = (RsvgNodeText *) node;
-            out = _rsvg_node_text_length_tspan (tspan, ctx, x, lastwasspace);
-        } else if (!strcmp (node->type->str, "tref")) {
-            RsvgNodeTref *tref = (RsvgNodeTref *) node;
-            out = _rsvg_node_text_length_tref (tref, ctx, x, lastwasspace);
+        } else {
+            if (usetextonly) {
+                out = _rsvg_node_text_length_children(node, ctx, length,
+                                                      lastwasspace,
+                                                      usetextonly);
+            } else {
+                if (type == RSVG_NODE_TYPE_TSPAN) {
+                    RsvgNodeText *tspan = (RsvgNodeText *) node;
+                    out = _rsvg_node_text_length_tspan (tspan, ctx, length,
+                                                        lastwasspace,
+                                                        usetextonly);
+                } else if (type == RSVG_NODE_TYPE_TREF) {
+                    RsvgNodeTref *tref = (RsvgNodeTref *) node;
+                    out = _rsvg_node_text_length_tref (tref, ctx, length,
+                                                       lastwasspace,
+                                                       usetextonly);
+                }
+            }
         }
+        rsvg_state_pop (ctx);
         if (out)
             break;
     }
@@ -238,27 +263,39 @@ _rsvg_node_text_length_children (RsvgNode * self, RsvgDrawingCtx * ctx,
 static void
 _rsvg_node_text_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 {
-    double x, y;
+    double x, y, dx, dy, length = 0;
     gboolean lastwasspace = TRUE;
     RsvgNodeText *text = (RsvgNodeText *) self;
     rsvg_state_reinherit_top (ctx, self->state, dominate);
 
     x = _rsvg_css_normalize_length (&text->x, ctx, 'h');
     y = _rsvg_css_normalize_length (&text->y, ctx, 'v');
-    x += _rsvg_css_normalize_length (&text->dx, ctx, 'h');
-    y += _rsvg_css_normalize_length (&text->dy, ctx, 'v');
-
-    if (rsvg_state_current (ctx)->text_anchor != TEXT_ANCHOR_START) {
-        double length = 0;
-        _rsvg_node_text_length_children (self, ctx, &length, &lastwasspace);
-        if (rsvg_state_current (ctx)->text_anchor == TEXT_ANCHOR_END)
-            x -= length;
-        if (rsvg_state_current (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
-            x -= length / 2;
+    dx = _rsvg_css_normalize_length (&text->dx, ctx, 'h');
+    dy = _rsvg_css_normalize_length (&text->dy, ctx, 'v');
+
+    if (rsvg_current_state (ctx)->text_anchor != TEXT_ANCHOR_START) {
+        _rsvg_node_text_length_children (self, ctx, &length, &lastwasspace, FALSE);
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+            length /= 2;
     }
+    if (PANGO_GRAVITY_IS_VERTICAL (rsvg_current_state (ctx)->text_gravity)) {
+        y -= length;
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+            dy /= 2;
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_END)
+            dy = 0;
+    } else {
+        x -= length;
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+            dx /= 2;
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_END)
+            dx = 0;
+    }
+    x += dx;
+    y += dy;
 
     lastwasspace = TRUE;
-    _rsvg_node_text_type_children (self, ctx, &x, &y, &lastwasspace);
+    _rsvg_node_text_type_children (self, ctx, &x, &y, &lastwasspace, FALSE);
 }
 
 RsvgNode *
@@ -266,7 +303,7 @@ rsvg_new_text (void)
 {
     RsvgNodeText *text;
     text = g_new (RsvgNodeText, 1);
-    _rsvg_node_init (&text->super);
+    _rsvg_node_init (&text->super, RSVG_NODE_TYPE_TEXT);
     text->super.draw = _rsvg_node_text_draw;
     text->super.set_atts = _rsvg_node_text_set_atts;
     text->x = text->y = text->dx = text->dy = _rsvg_css_parse_length ("0");
@@ -275,36 +312,65 @@ rsvg_new_text (void)
 
 static void
 _rsvg_node_text_type_tspan (RsvgNodeText * self, RsvgDrawingCtx * ctx,
-                            gdouble * x, gdouble * y, gboolean * lastwasspace)
+                            gdouble * x, gdouble * y, gboolean * lastwasspace,
+                            gboolean usetextonly)
 {
+    double dx, dy, length = 0;
     rsvg_state_reinherit_top (ctx, self->super.state, 0);
 
+    dx = _rsvg_css_normalize_length (&self->dx, ctx, 'h');
+    dy = _rsvg_css_normalize_length (&self->dy, ctx, 'v');
+
+    if (rsvg_current_state (ctx)->text_anchor != TEXT_ANCHOR_START) {
+        gboolean lws = *lastwasspace;
+        _rsvg_node_text_length_children (&self->super, ctx, &length, &lws,
+                                         usetextonly);
+        if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+            length /= 2;
+    }
+
     if (self->x.factor != 'n') {
         *x = _rsvg_css_normalize_length (&self->x, ctx, 'h');
-        if (rsvg_state_current (ctx)->text_anchor != TEXT_ANCHOR_START) {
-            double length = 0;
-            gboolean lws = *lastwasspace;
-            _rsvg_node_text_length_children (&self->super, ctx, &length, &lws);
-            if (rsvg_state_current (ctx)->text_anchor == TEXT_ANCHOR_END)
-                *x -= length;
-            if (rsvg_state_current (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
-                *x -= length / 2;
+        if (!PANGO_GRAVITY_IS_VERTICAL (rsvg_current_state (ctx)->text_gravity)) {
+            *x -= length;
+            if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+                dx /= 2;
+            if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_END)
+                dx = 0;
         }
     }
-    if (self->y.factor != 'n')
+    *x += dx;
+
+    if (self->y.factor != 'n') {
         *y = _rsvg_css_normalize_length (&self->y, ctx, 'v');
-    *x += _rsvg_css_normalize_length (&self->dx, ctx, 'h');
-    *y += _rsvg_css_normalize_length (&self->dy, ctx, 'v');
-    _rsvg_node_text_type_children (&self->super, ctx, x, y, lastwasspace);
+        if (PANGO_GRAVITY_IS_VERTICAL (rsvg_current_state (ctx)->text_gravity)) {
+            *y -= length;
+            if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_MIDDLE)
+                dy /= 2;
+            if (rsvg_current_state (ctx)->text_anchor == TEXT_ANCHOR_END)
+                dy = 0;
+        }
+    }
+    *y += dy;
+    _rsvg_node_text_type_children (&self->super, ctx, x, y, lastwasspace,
+                                   usetextonly);
 }
 
 static int
-_rsvg_node_text_length_tspan (RsvgNodeText * self, RsvgDrawingCtx * ctx, gdouble * x,
-                              gboolean * lastwasspace)
+_rsvg_node_text_length_tspan (RsvgNodeText * self,
+                              RsvgDrawingCtx * ctx, gdouble * length,
+                              gboolean * lastwasspace, gboolean usetextonly)
 {
     if (self->x.factor != 'n' || self->y.factor != 'n')
         return TRUE;
-    return _rsvg_node_text_length_children (&self->super, ctx, x, lastwasspace);
+
+    if (PANGO_GRAVITY_IS_VERTICAL (rsvg_current_state (ctx)->text_gravity))
+        *length += _rsvg_css_normalize_length (&self->dy, ctx, 'v');
+    else
+        *length += _rsvg_css_normalize_length (&self->dx, ctx, 'h');
+
+    return _rsvg_node_text_length_children (&self->super, ctx, length,
+                                             lastwasspace, usetextonly);
 }
 
 static void
@@ -338,7 +404,7 @@ rsvg_new_tspan (void)
 {
     RsvgNodeText *text;
     text = g_new (RsvgNodeText, 1);
-    _rsvg_node_init (&text->super);
+    _rsvg_node_init (&text->super, RSVG_NODE_TYPE_TSPAN);
     text->super.set_atts = _rsvg_node_tspan_set_atts;
     text->x.factor = text->y.factor = 'n';
     text->dx = text->dy = _rsvg_css_parse_length ("0");
@@ -347,19 +413,49 @@ rsvg_new_tspan (void)
 
 static void
 _rsvg_node_text_type_tref (RsvgNodeTref * self, RsvgDrawingCtx * ctx,
-                           gdouble * x, gdouble * y, gboolean * lastwasspace)
+                           gdouble * x, gdouble * y, gboolean * lastwasspace,
+                           gboolean usetextonly)
 {
-    if (self->link)
-        _rsvg_node_text_type_children (self->link, ctx, x, y, lastwasspace);
+    RsvgNode *link;
+
+    if (self->link == NULL)
+      return;
+    link = rsvg_acquire_node (ctx, self->link);
+    if (link == NULL)
+      return;
+
+    _rsvg_node_text_type_children (link, ctx, x, y, lastwasspace,
+                                                    TRUE);
+
+    rsvg_release_node (ctx, link);
 }
 
 static int
 _rsvg_node_text_length_tref (RsvgNodeTref * self, RsvgDrawingCtx * ctx, gdouble * x,
-                             gboolean * lastwasspace)
+                             gboolean * lastwasspace, gboolean usetextonly)
 {
-    if (self->link)
-        return _rsvg_node_text_length_children (self->link, ctx, x, lastwasspace);
-    return FALSE;
+    gboolean result;
+    RsvgNode *link;
+
+    if (self->link == NULL)
+      return FALSE;
+    link = rsvg_acquire_node (ctx, self->link);
+    if (link == NULL)
+      return FALSE;
+
+    result = _rsvg_node_text_length_children (link, ctx, x, lastwasspace, TRUE);
+
+    rsvg_release_node (ctx, link);
+
+    return result;
+}
+
+static void
+rsvg_node_tref_free (RsvgNode * node)
+{
+    RsvgNodeTref *self = (RsvgNodeTref *) node;
+    g_free (self->link);
+    _rsvg_node_free (node);
 }
 
 static void
@@ -369,8 +465,10 @@ _rsvg_node_tref_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * a
     RsvgNodeTref *text = (RsvgNodeTref *) self;
 
     if (rsvg_property_bag_size (atts)) {
-        if ((value = rsvg_property_bag_lookup (atts, "xlink:href")))
-            rsvg_defs_add_resolver (ctx->priv->defs, &text->link, value);
+        if ((value = rsvg_property_bag_lookup (atts, "xlink:href"))) {
+            g_free (text->link);
+            text->link = g_strdup (value);
+        }
         if ((value = rsvg_property_bag_lookup (atts, "id")))
             rsvg_defs_register_name (ctx->priv->defs, value, self);
     }
@@ -381,7 +479,8 @@ rsvg_new_tref (void)
 {
     RsvgNodeTref *text;
     text = g_new (RsvgNodeTref, 1);
-    _rsvg_node_init (&text->super);
+    _rsvg_node_init (&text->super, RSVG_NODE_TYPE_TREF);
+    text->super.free = rsvg_node_tref_free;
     text->super.set_atts = _rsvg_node_tref_set_atts;
     text->link = NULL;
     return &text->super;
@@ -394,121 +493,12 @@ struct _RsvgTextLayout {
     RsvgDrawingCtx *ctx;
     TextAnchor anchor;
     gdouble x, y;
-    gboolean orientation;
 };
 
-typedef struct _RenderCtx RenderCtx;
-
-struct _RenderCtx {
-    GString *path;
-    gboolean wrote;
-    gdouble offset_x;
-    gdouble offset_y;
-};
-
-#ifdef CAIRO_HAS_FT_FONT
-typedef void (*RsvgTextRenderFunc) (PangoFont * font,
-                                    PangoGlyph glyph,
-                                    FT_Int32 load_flags, gint x, gint y, gpointer render_data);
-
-#ifndef FT_GLYPH_FORMAT_OUTLINE
-#define FT_GLYPH_FORMAT_OUTLINE ft_glyph_format_outline
-#endif
-
-#ifndef FT_LOAD_TARGET_MONO
-#define FT_LOAD_TARGET_MONO FT_LOAD_MONOCHROME
-#endif
-#endif /* CAIRO_HAS_FT_FONT */
-
-static RenderCtx *
-rsvg_render_ctx_new (void)
-{
-    RenderCtx *ctx;
-
-    ctx = g_new0 (RenderCtx, 1);
-    ctx->path = g_string_new (NULL);
-
-    return ctx;
-}
-
-static void
-rsvg_render_ctx_free (RenderCtx * ctx)
-{
-    g_string_free (ctx->path, TRUE);
-    g_free (ctx);
-}
-
-#ifdef CAIRO_HAS_FT_FONT
-static void
-rsvg_text_ft2_subst_func (FcPattern * pattern, gpointer data)
-{
-    RsvgHandle *ctx = (RsvgHandle *) data;
-
-    (void) ctx;
-
-    FcPatternAddBool (pattern, FC_HINTING, 0);
-    FcPatternAddBool (pattern, FC_ANTIALIAS, 0);
-    FcPatternAddBool (pattern, FC_AUTOHINT, 0);
-    FcPatternAddBool (pattern, FC_SCALABLE, 1);
-}
-
-static PangoContext *
-rsvg_text_get_pango_context (RsvgDrawingCtx * ctx)
-{
-    PangoContext *context;
-    PangoFT2FontMap *fontmap;
-
-    fontmap = PANGO_FT2_FONT_MAP (pango_ft2_font_map_new ());
-
-    pango_ft2_font_map_set_resolution (fontmap, ctx->dpi_x, ctx->dpi_y);
-
-    pango_ft2_font_map_set_default_substitute (fontmap,
-                                               rsvg_text_ft2_subst_func,
-                                               ctx, (GDestroyNotify) NULL);
-
-    context = pango_ft2_font_map_create_context (fontmap);
-    g_object_unref (fontmap);
-
-    /*  Workaround for bug #143542 (PangoFT2Fontmap leak),
-     *  see also bug #344235 (Text layer rendering leaks font file descriptor):
-     *
-     *  Calling pango_ft2_font_map_substitute_changed() causes the
-     *  font_map cache to be flushed, thereby removing the circular
-     *  reference that causes the leak.
-     */
-    g_object_weak_ref (G_OBJECT (context),
-                       (GWeakNotify) pango_ft2_font_map_substitute_changed, fontmap);
-
-
-    return context;
-}
-#else
-/* although the #if condtionalizes on FT2 here we try to use pure cairo */
-typedef void (*RsvgTextRenderFunc) (PangoFont * font,
-                                    PangoGlyph glyph,
-                                    gint x, gint y, gpointer render_data);
-
-static PangoContext *
-rsvg_text_get_pango_context (RsvgDrawingCtx * ctx)
-{
-    PangoContext *context;
-    PangoCairoFontMap *fontmap;
-    
-    fontmap = PANGO_CAIRO_FONT_MAP (pango_cairo_font_map_new ());
-    if (ctx->dpi_x != ctx->dpi_y)
-	g_warning ("asymmetric dpi not handled");
-    pango_cairo_font_map_set_resolution (fontmap, ctx->dpi_x);
-    context = pango_cairo_font_map_create_context (fontmap);
-    g_object_unref (fontmap);
-    
-    return context;
-}
-#endif /* #ifdef CAIRO_HAS_FT_FONT */
-
 static void
 rsvg_text_layout_free (RsvgTextLayout * layout)
 {
-    g_object_unref (G_OBJECT (layout->layout));
+    g_object_unref (layout->layout);
     g_free (layout);
 }
 
@@ -527,6 +517,9 @@ rsvg_text_create_layout (RsvgDrawingCtx * ctx,
     if (state->unicode_bidi == UNICODE_BIDI_OVERRIDE || state->unicode_bidi == UNICODE_BIDI_EMBED)
         pango_context_set_base_dir (context, state->text_dir);
 
+    if (PANGO_GRAVITY_IS_VERTICAL (state->text_gravity))
+        pango_context_set_base_gravity (context, state->text_gravity);
+
     font_desc = pango_font_description_copy (pango_context_get_font_description (context));
 
     if (state->font_family)
@@ -537,17 +530,16 @@ rsvg_text_create_layout (RsvgDrawingCtx * ctx,
     pango_font_description_set_weight (font_desc, state->font_weight);
     pango_font_description_set_stretch (font_desc, state->font_stretch);
     pango_font_description_set_size (font_desc,
-                                     _rsvg_css_normalize_length (&state->font_size, ctx,
-                                                                 'v') * PANGO_SCALE / ctx->dpi_y *
-                                     72);
+                                     _rsvg_css_normalize_font_size (state, ctx) *
+                                     PANGO_SCALE / ctx->dpi_y * 72);
 
     layout = pango_layout_new (context);
     pango_layout_set_font_description (layout, font_desc);
     pango_font_description_free (font_desc);
 
     attr_list = pango_attr_list_new ();
-    attribute = pango_attr_letter_spacing_new ( _rsvg_css_normalize_length (&state->letter_spacing, 
-									    ctx, 'h') * PANGO_SCALE);
+    attribute = pango_attr_letter_spacing_new (_rsvg_css_normalize_length (&state->letter_spacing,
+                                                                           ctx, 'h') * PANGO_SCALE);
     attribute->start_index = 0;
     attribute->end_index = G_MAXINT;
     pango_attr_list_insert (attr_list, attribute); 
@@ -575,8 +567,7 @@ rsvg_text_create_layout (RsvgDrawingCtx * ctx,
     else
         pango_layout_set_text (layout, NULL, 0);
 
-    pango_layout_set_alignment (layout, (state->text_dir == PANGO_DIRECTION_LTR ||
-                                         state->text_dir == PANGO_DIRECTION_TTB_LTR) ?
+    pango_layout_set_alignment (layout, (state->text_dir == PANGO_DIRECTION_LTR) ?
                                 PANGO_ALIGN_LEFT : PANGO_ALIGN_RIGHT);
 
     return layout;
@@ -589,7 +580,7 @@ rsvg_text_layout_new (RsvgDrawingCtx * ctx, RsvgState * state, const char *text)
     RsvgTextLayout *layout;
 
     if (ctx->pango_context == NULL)
-        ctx->pango_context = rsvg_text_get_pango_context (ctx);
+        ctx->pango_context = ctx->render->create_pango_context (ctx);
 
     layout = g_new0 (RsvgTextLayout, 1);
 
